package dk.apaq.framework.criteria.mongo;


import dk.apaq.framework.criteria.mongo.CriteriaForMongoDb;
import dk.apaq.framework.criteria.Criteria;
import dk.apaq.framework.criteria.Limit;
import dk.apaq.framework.criteria.Rule;
import dk.apaq.framework.criteria.Rules;
import dk.apaq.framework.criteria.Sorter;
import dk.apaq.framework.criteria.rules.AndRule;
import dk.apaq.framework.criteria.rules.CompareRule;
import dk.apaq.framework.criteria.rules.OrRule;

import org.junit.Test;
import static org.junit.Assert.*;
import org.springframework.data.mongodb.core.query.Query;

/**
 *
 * @author krog
 */
public class RulesForMongoDbTest {
    
    

    @Test
    public void testTranslate() {
        System.out.println("translate");
        String[] fields = null;
        Class entityClass = null;
        Rule rule = Rules.and(
                        Rules.equals("name", "michael"),
                        Rules.or(
                            Rules.lessOrEqual("age", 35),
                            Rules.greaterOrEqual("age", 50)
                    )
                );
                
        Sorter sorter = new Sorter("age");
        Limit limit = new Limit(1, 2);
        
        String expResult = "Query: { \"$and\" : [ { \"name\" : \"michael\"} , { \"$or\" : [ { \"age\" : { \"$lte\" : 35}} , { \"age\" : { \"$gte\" : 50}}]}]}, Fields: null, Sort: { \"age\" : 1}";
        Query result = CriteriaForMongoDb.translate(entityClass, new Criteria(rule, sorter, limit));
        String queryString = result.toString();
        assertEquals(expResult, queryString);

    }
}
