
package dk.apaq.framework.criteria.simplequery;

import dk.apaq.framework.criteria.Rule;


/**
 * Utility class for translating Criterias to and from SimpleQuery.<br>
 * <br>
 * The translation is done by using <code>SimpleQueryComposer</code> and <code>SimpleQueryParser</code>.
 * If more control is wanted over the translation an instance of the <code>SimpleQueryComposer</code> or 
 * <code>SimpleQueryParser</code> should be instantiated instead.
 * 
 */
public final class CriteriaForSimpleQuery {

    private static final SimpleQueryComposer COMPOSER = new SimpleQueryComposer();
    private static final SimpleQueryParser PARSER = new SimpleQueryParser();
    
    private CriteriaForSimpleQuery() { /* EMPTY */ }
    
    public static String translate(Rule rule) {
        return COMPOSER.compose(rule);
    }
    
    public static Rule translate(String query) {
        return PARSER.parse(query);
    }
    
}
