package dk.apaq.framework.criteria.simplequery.interpreters;

import dk.apaq.framework.criteria.rules.BetweenRule;


/**
 *
 */
public class BetweenRuleInterpreter implements Interpreter<BetweenRule> {

    public boolean interpret(StringBuilder query, BetweenRule rule) {
        query.append(rule.getPropertyId()).
                append(" = ").
                append("[").
                append(formatValue(rule.getStartValue())).
                append(" TO ").append(formatValue(rule.getEndValue())).
                append("]");
        return true;
    }
    
    private String formatValue(Object value) {
        if(value == null) {
            return null;
        }
        
        if(value instanceof String) {
            return "\"" + value + "\"";
        } else {
            return value.toString();
        }
    }
}
