package dk.apaq.framework.criteria.simplequery.interpreters;

import dk.apaq.framework.criteria.rules.CompareRule;


/**
 *
 */
public class ContainsRuleInterpreter implements Interpreter<CompareRule> {

    public boolean interpret(StringBuilder query, CompareRule rule) {
        String operator = null;

        switch (rule.getCompareType()) {
            case GreaterOrEqual:
                operator = ">=";
                break;
            case GreaterThan:
                operator = ">";
                break;
            case LessOrEqual:
                operator = "<=";
                break;
            case LessThan:
                operator = "<";
                break;
            case Equals:
            default:
                operator = "=";
                break;
            
        }

        query.append(rule.getPropertyId()).append(operator);

        if(rule.getValue() instanceof String) {
            query.append("\"").append(rule.getValue()).append("\"");
        } else {
            query.append(rule.getValue());
        }
        return true;
    }
}
