package dk.apaq.framework.criteria.simplequery.interpreters;

import dk.apaq.framework.criteria.rules.InRule;


/**
 * Interprets InRule for Simple Query.
 */
public class InRuleInterpreter implements Interpreter<InRule> {

    public boolean interpret(StringBuilder query, InRule rule) {
        if (rule.getValues() == null) {
            return false;
        }

        int count = 0;
        query.append(rule.getPropertyId()).append(" IN (");

        for (Object value : rule.getValues()) {
            if (count > 0) {
                query.append(",");
            }

            if (value instanceof String) {
                query.append('\"').append(value).append("\"");
            } else {
                query.append(value);
            }
            count++;
        }
        query.append(")");

        return true;
    }
}
