/*
 * Apaq Framework
 * Copyright (C) 2011-2013 by Apaq
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package dk.apaq.framework.criteria;

/**
 * Interface for at Rule. A rule is used to specify which data is wanted during af search for data. It can be used
 * programatically using the passesRule method, or by translating the data found in the rule to another Criteria API.<br>
 * (The latter is done in the Criteria API for JPA and MongoDb)
 */
public interface Rule {
    
    public interface FiltrationItem {

        public Object getFiltrationProperty(String propertyId) ;

    }


    /**
     * Checks wether a specific item passes the rule.
     * @param item The item to check.
     * @return True/False
     */
    public boolean passesRule(FiltrationItem item);
}
