/*
 * Apaq Framework
 * Copyright (C) 2011-2013 by Apaq
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package dk.apaq.framework.criteria;

/**
 * Interface for a specific rule. A specific rule is the 'opposite' of a RuleCollection.
 * This interface marks one single specific rule that does not wrap a collection of other 
 * rules.
 */
public interface SpecificRule extends Rule {

    /**
     * Retrieves the property which the Filter works on.
     * @return The propertyId.
     */
    public String getPropertyId();
}
