package dk.apaq.framework.criteria;

import dk.apaq.framework.criteria.Sorter;
import dk.apaq.framework.criteria.Criteria;
import dk.apaq.framework.criteria.Rules;
import dk.apaq.framework.criteria.Limit;
import dk.apaq.framework.criteria.CriteriaUtil;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import dk.apaq.framework.criteria.Rule.FiltrationItem;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author michael
 */
public class CriteriaUtilTest {
    
    private List<Person> persons = new ArrayList<Person>();
    
    @Before
    public void init() {
        persons.add(new Person("Michael Krog", 33, 197, true, "Micker"));
        persons.add(new Person("Hannah Krog", 30, 170, false));
        persons.add(new Person("Fister Krog", 32, 1730, true));
        persons.add(new Person("John Doe", 1000, 181, true));
        persons.add(new Person(null, 123, 161, false));
    }
            
    /**
     * Test of filterCollection method, of class CriteriaUtil.
     */
    @Test
    public void testFilterCollection_Collection_Criteria() {
        System.out.println("filterCollection");
        
        Criteria c = new Criteria(Rules.like("name", "*krog", false), new Sorter("age", Sorter.Direction.Descending), new Limit(1,2));
        
        List<Person> result = CriteriaUtil.filterCollection(persons, c);
        
        assertEquals(2, result.size());
        assertEquals(persons.get(2), result.get(0));
        assertEquals(persons.get(1), result.get(1));
    }
}
