package dk.apaq.framework.repository.mongo;

import dk.apaq.framework.repository.mongo.MongodbRepository;
import dk.apaq.framework.criteria.Criteria;
import dk.apaq.framework.criteria.Rules;
import dk.apaq.framework.criteria.rules.CompareRule;
import org.junit.*;
import org.junit.runner.RunWith;
import static org.junit.Assert.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.data.mongodb.repository.support.MongoRepositoryFactory;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 *
 * @author krog
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations={"/defaultspringcontext.xml"})
@Ignore
public class MongodbRepositoryTest {
    
    @Autowired
    private MongoOperations mongoOperations;
   
    //@Test
    public void testRead() {
        System.out.println("read");
        MongoRepositoryFactory factory = new MongoRepositoryFactory(mongoOperations);
        MongodbRepository<MongoBean, String> instance = new MongodbRepository<MongoBean, String>(factory, mongoOperations, MongoBean.class);
        
        MongoBean result = instance.save(new MongoBean());
        assertNotNull(result);
        
        String id = result.getId();
        
        instance.delete(id);
        result = instance.findOne(id);
        assertNull(result);
        
    }

    //@Test
    public void testListIds() {
        System.out.println("read");
        MongoRepositoryFactory factory = new MongoRepositoryFactory(mongoOperations);
        MongodbRepository<MongoBean, String> instance = new MongodbRepository<MongoBean, String>(factory, mongoOperations, MongoBean.class);
        
        instance.save(new MongoBean("Michael Krog", 33));
        instance.save(new MongoBean("Hannah Krog", 30));
        instance.save(new MongoBean("Martin Krog", 38));
        
        assertEquals(3, instance.findAll().size());
        assertEquals(2, instance.findAll(new Criteria(Rules.greaterThan("age", 32))).size());
        assertEquals(1, instance.findAll(new Criteria(Rules.equals("name", "Hannah Krog"))).size());
        
        for(int i=0;i<1000;i++)
            instance.save(new MongoBean());
        
        for(MongoBean bean : instance.findAll())
            instance.delete(bean);
        
    }
    
    @Test
    public void dummy() {
    }
    
    /*

    @Test
    public void testList() {
        System.out.println("list");
        Rule filter = null;
        Sorter sorter = null;
        Limit limit = null;
        MongodbRepository instance = null;
        List expResult = null;
        List result = instance.list(filter, sorter, limit);
        assertEquals(expResult, result);
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }

    @Test
    public void testCreate_0args() {
        System.out.println("create");
        MongodbRepository instance = null;
        Object expResult = null;
        Object result = instance.create();
        assertEquals(expResult, result);
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }

    @Test
    public void testCreate_GenericType() {
        System.out.println("create");
        BEANTYPE entity = null;
        MongodbRepository instance = null;
        Object expResult = null;
        Object result = instance.create(entity);
        assertEquals(expResult, result);
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }

    @Test
    public void testCreateAndRead() {
        System.out.println("createAndRead");
        BEANTYPE entity = null;
        MongodbRepository instance = null;
        HasId expResult = null;
        HasId result = instance.createAndRead(entity);
        assertEquals(expResult, result);
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }

    @Test
    public void testUpdate() {
        System.out.println("update");
        Object entity = null;
        MongodbRepository instance = null;
        Object expResult = null;
        Object result = instance.update(entity);
        assertEquals(expResult, result);
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }

    @Test
    public void testDelete() {
        System.out.println("delete");
        Object id = null;
        MongodbRepository instance = null;
        instance.delete(id);
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }*/
}
